package storeMySQL;

use strict;
use DBI;
use POSIX qw( strftime );
use constant TIMEFORMAT => '%d-%b-%y %T';

BEGIN {
	print "PlugIns storeMySQL loaded - Write data in mySQL database\n";
}

sub new {
	my %rec;
	our $host;
	our $database;
	our $login;
	our $password;

	do 'domo.conf';

	my $self  = {
		_verbose => 0,
		_data => \%rec,
		_host => $host,
		_database => $database,
		_login => $login,
		_password =>$password
	};
	bless($self);
	return $self;
}

sub name {
	return "storeMySQL";
}

sub verbose {
	my ( $self, $verbose ) = @_;
	$self->{_verbose} = $verbose if defined($verbose);
	return $self->{_verbose};
}

sub process {
	my ($self, $timeformat, $min, $str) = @_;

	# open database
	my $host = $self->{_host};
	my $database = $self->{_database};
	my $login = $self->{_login};
	my $password = $self->{_password};
	my $verbose = $self->{_verbose};

	print "storeMySQL process\n" if ($verbose);

	my $dsn = "DBI:mysql:database=$database;host=$host";
	my $dbh = DBI->connect($dsn, $login, $password) or die "Echec connexion";

	read_data($dbh, $str, $verbose);

	$dbh->disconnect;
}

sub read_data {
	my ($dbh, $str, $verbose) = @_;

	my @lines = split (/\n/, $str);
	foreach my $line (@lines) {
		chomp $line;
		next if ($line eq '');
		my ($proto, $addr, $type, $val) = split(' ', $line);
		# $n = substr($n, 0, 12);
		if ($proto eq 'TX' || $proto eq 'AC' || $proto eq 'IO' || $proto eq 'VT' || $proto eq 'EL' || $proto eq 'WS') {
			# print("\"$proto $addr $type $val \" \n");
			# $n =~ s/'/\\'/g; # for names including quotes
			my $query = "SELECT val FROM valeurs WHERE proto='$proto' AND type='$type' AND addr='$addr'";
			print "$query\n" if ($verbose);
			my $sth = $dbh->prepare($query);
			if (!$sth->execute()) {
				print "error execute \"$query\": dbh->errstr\n";
			}
			if ($sth->rows) {
				$query = "UPDATE valeurs SET val='$val',date=NULL WHERE proto='$proto' AND type='$type' AND addr='$addr'";
			}
			else {
				$query = "INSERT INTO valeurs (proto,type,addr,val) VALUES('$proto','$type','$addr','$val')";
			}
			print "$query\n" if ($verbose);
			$sth = $dbh->prepare($query);
			if (!$sth->execute()) {
				print "error execute \"$query\": dbh->errstr\n";
			}
			$sth->finish();
		}
	}
}

END {
#	print "PlugIns storeMySQL unloaded\n";
}

1;  # so the require or use succeeds

